#ifndef _DOUBLEBUFF_H_
#define _DOUBLEBUFF_H_
#include "stdafx.h"

class CBitmap;
class CDC;

class DoubleBuff {
public:
  DoubleBuff();
  virtual ~DoubleBuff();
  void DrawLine(int x1,int y1, int x2,int y2);
  void DrawString(int x,int y,char* str,int fontID = 0);
  int CreateFont(int id,char* font);
  CRect* GetClientRect(){ return &clientRect;}
  void Initialize(CRect* rct);
  void ClearCanvas();
  void Update();
  void SetCDC(CDC* pDC){
    displayDC = pDC;
  }
  HDC GetHDC(){
    if(memDC != NULL)
      return memDC->GetSafeHdc();
    else
      return 0;
  }
  CDC *GetCDC(){
	return memDC;
  }
private:
  void CreateMemDC();
  void CreateBitmap();
  CDC* memDC;
  CDC* displayDC;
  CBitmap* dispBuf;
  CRect clientRect;
};

#endif
