#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ParsePacket.h"

void PacketItem::CopyThis(void* ptr,int size)
{
  memcpy(ptr,this,size);
}

void PacketItem::SetField(char* ptr, int n)
{
  sprintf(ptr,"%d",n);
}

void PacketItem::SetField(char* ptr, char* str)
{
  sprintf(ptr,"%s",str);
}

int MakePacket::MakePositionPacket(char* buf, int x, int y)
{
  ComHeader header(C_POSITION,sizeof(ComPosition));
  ComPosition position(x,y);

  header.CopyThis(buf,sizeof(ComHeader));
  position.CopyThis(buf+sizeof(ComHeader),sizeof(ComPosition));
  return sizeof(ComHeader)+sizeof(ComPosition);
}

int MakePacket::MakeStartPacket(char* buf, int isSente)
{
  ComHeader header(C_START,sizeof(ComStart));
  ComStart start(isSente);

  header.CopyThis(buf,sizeof(ComHeader));
  start.CopyThis(buf+sizeof(ComHeader),sizeof(ComStart));
  return sizeof(ComHeader)+sizeof(ComStart);
}

int MakePacket::MakeGiveUpPacket(char* buf)
{
  ComHeader header(C_GIVEUP,0);

  header.CopyThis(buf,sizeof(ComHeader));
  return sizeof(ComHeader);
}
