// vsgomoku.cpp : AvP[VpNX̋@\`s܂B
//

#include "stdafx.h"
#include "vsgomoku.h"

#include "MainFrm.h"
#include "vsgomokuDoc.h"
#include "vsgomokuView.h"
#include "gomoku.h"
#include "ParsePacket.h"
#include "AnimatedString.h"

#include <io.h>
#include "mmsystem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuApp

BEGIN_MESSAGE_MAP(CVsgomokuApp, CWinApp)
	//{{AFX_MSG_MAP(CVsgomokuApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(MENU_CONNECT, OnConnect)
	ON_COMMAND(MENU_DISCONNECT, OnDisconnect)
	ON_UPDATE_COMMAND_UI(MENU_CONNECT, OnUpdateConnect)
	ON_UPDATE_COMMAND_UI(MENU_DISCONNECT, OnUpdateDisconnect)
	ON_COMMAND(MENU_GIVEUP, OnGiveup)
	ON_UPDATE_COMMAND_UI(MENU_GIVEUP, OnUpdateGiveup)
	ON_COMMAND(MENU_GOTE, OnGote)
	ON_UPDATE_COMMAND_UI(MENU_GOTE, OnUpdateGote)
	ON_COMMAND(MENU_SENTE, OnSente)
	ON_UPDATE_COMMAND_UI(MENU_SENTE, OnUpdateSente)
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuApp NX̍\z
CVsgomokuApp *global_app;

CVsgomokuApp::CVsgomokuApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
  global_app = this;
  playSound = TRUE;
  soundKind = 0;
  isPlaying = FALSE;
  about = NULL;
  if(_access(PUT_SOUNDFILE,04) == 0){
	soundKind |= PUT_SOUND;
  }
}

/////////////////////////////////////////////////////////////////////////////
// B CVsgomokuApp IuWFNg

CVsgomokuApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuApp NX̏

BOOL CVsgomokuApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// WIȏ
	// ̋@\gpAst@C̃TCY
	//  Έȉ̓̏[`̒sKvȂ
	//  폜ĂB

#ifdef _AFXDLL
	Enable3dControls();			// L DLL ̒ MFC gpꍇɂ͂ĂяoĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNĂꍇɂ͂ĂяoĂB
#endif

	// ݒ肪ۑ鉺̃WXg L[ύX܂B
	// Ж܂͏ȂǁAK؂ȕ
	// ύXĂB
	//SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // W INI t@C̃IvV[ނ܂ (MRU ܂)

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CVsgomokuDoc),
		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
		RUNTIME_CLASS(CVsgomokuView));
	AddDocTemplate(pDocTemplate);

	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// R}hCŃfBXpb` R}hw肵܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_canvas;
	//}}AFX_DATA

	// ClassWizard z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnOK();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	AnimatedString animation;
  DoubleBuff doubleBuff;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, VERSIONCANVAS, m_canvas);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CVsgomokuApp::OnAppAbout()
{
  if(about == NULL){
	about = new CAboutDlg;
  }
  about->DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuApp R}h

void CVsgomokuApp::OnConnect() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  goban.SetMyIshi(ISHI_KURO);
  connection.DoModal();
  if(connection.IsConnect()){
	global_frame->SetConnectStatus("ڑ");
	global_frame->SetStatusBar(MES_INIT);
  }
}

void CVsgomokuApp::OnDisconnect() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  global_app->isPlaying = FALSE;
  global_app->isPlaying = FALSE;
  global_app->connection.Close();
  global_frame->SetConnectStatus("ڑ");	
}

int CVsgomokuApp::SetIshi(int x, int y,int turn)
{
  // ܂n܂ĂȂƂ̓^[
  if(isPlaying == FALSE)
	return FALSE;

  // uԂȂƂ̓^[
  if(turn == MY_TURN && !goban.IsMyTurn())
	return FALSE;

  if(goban.SetIshi(x,y,turn) == TRUE){
	WinLoseStatus status;
	// o 
	if(playSound && (soundKind & PUT_SOUND)){
	  sndPlaySound(PUT_SOUNDFILE,SND_ASYNC);
	}
	if(turn == MY_TURN){
	  // ɏꏊ𑗐M
	  char buf[BUFSIZ];
	  int size = packet.MakePositionPacket(buf,x,y);
	  EasySocket *socket = connection.GetSocket();
	  socket->Send(buf,size);
	  goban.SetMyTurn(FALSE);
	  global_frame->SetStatusBar(MES_TEKITURN);
	  global_view->SetIshi(x,y, goban.GetMyIshi());
	  // ̑ł΂̏Ԃ𒲂ׂ
	  status = CheckWinLose(x,y,goban.GetMyIshi());
	  switch(status){
	  case STATUS_WIN:
		// I
		isPlaying = FALSE;
		AfxMessageBox("Ȃ̏łI",MB_OK);
		break;
	  case STATUS_LOSE:
		// I
		isPlaying = FALSE;
		AfxMessageBox("֎ɂ肠Ȃ̕łI\n"
					  "(͎OOAllAA͋ւł)",MB_OK);
		break;
	  }
	} else {
	  goban.SetMyTurn(TRUE);
	  global_frame->SetStatusBar(MES_OWNTURN);
	  global_view->SetIshi(x,y, goban.GetTekiIshi());
	  // G̑ł΂̏Ԃ𒲂ׂ
	  status = CheckWinLose(x,y,goban.GetTekiIshi());
	  switch(status){
	  case STATUS_WIN:
		// iG̏Ij
		isPlaying = FALSE;
		AfxMessageBox("Ȃ̕łI",MB_OK);
		break;
	  case STATUS_LOSE:
		// iĜ܂Ij
		isPlaying = FALSE;
		AfxMessageBox("̋֎ɂAȂ̏łI",MB_OK);
		break;
	  }
	}
	// sĂāA܂Jn{^ĂȂƂ
	if(isPlaying == FALSE){
	  	global_frame->SetStatusBar(MES_INIT);
	}
	return TRUE;
  } else
	return FALSE;
}

void CVsgomokuApp::OnUpdateConnect(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->Enable(!connection.IsConnect());
}

void CVsgomokuApp::OnUpdateDisconnect(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->Enable(connection.IsConnect());
}

void CVsgomokuApp::ReceiveCallback(void* soc)
{
  EasySocket* socket = (EasySocket*)soc;
  
  // {͂ŃvgRӎȂ񂾂
  // Kɂ
  ComHeader header;
  ComStart start;
  ComPosition position;
  ComType type;
  void* receiveBuf;
  int size;

  // ܂wb_[ǂ
  int result;
  if((result = socket->Receive(&header,sizeof(header))) != sizeof(header)){
	TRACE("MG[ MTCYF%d (v%d) G[F%d\n",
		  result, sizeof(header), socket->GetLastError());
	return;
  }

  // ɓeǂ

  switch((type = header.GetPacketType())){
  case C_START:
	receiveBuf = &start;
	size = sizeof(start);
	break;
  case C_POSITION:
	receiveBuf = &position;
	size = sizeof(position);
	break;
  case C_GIVEUP:
	size = 0;
		break;
  default:
	TRACE("pPbgG[ type:%d\n",type);
	return;
  }
  // pPbgĂȂ瑱ǂ
  if(size != 0){
	if((result = socket->Receive(receiveBuf,size)) != size){
	  TRACE("MG[ MTCYF%d (v%d) G[F%d\n",
			result, size, socket->GetLastError());
	  return;
	}
  }

  // pPbgɂ鏈
  switch(type){
  case C_START:
	global_app->Start(!start.GetIsSente());
	break;
  case C_POSITION:
	global_app->SetIshi(position.GetX(),position.GetY(),TEKI_TURN);
	break;
  case C_GIVEUP:
	global_app->GiveUp();
	break;
  }
}	
 
void CVsgomokuApp::CloseCallback(void* nouse)
{
  AfxMessageBox("ΐ푊Ƃ̐ڑؒf܂B̂܂B",
				MB_OK);
  global_app->isPlaying = FALSE;
  global_app->connection.Close();
  global_frame->SetConnectStatus("ڑ");	
}
 
void CVsgomokuApp::Start(int isSente)
{
  if(isSente){
	goban.SetMyIshi(ISHI_KURO);
	goban.SetMyTurn(TRUE);
	global_frame->SetStatusBar(MES_OWNTURN);
  }
  else {
	goban.SetMyIshi(ISHI_SHIRO);
	goban.SetMyTurn(FALSE);
	global_frame->SetStatusBar(MES_TEKITURN);
  }
  isPlaying = TRUE;
  goban.InitGoban();
  global_view->InitGoban();
  global_view->Invalidate(FALSE);
  global_view->UpdateWindow();
}

void CVsgomokuApp::GiveUp()
{
  isPlaying = FALSE;
  AfxMessageBox("ΐ푊肪~Q܂BȂ̏łB",
				MB_OK|MB_ICONINFORMATION);
  if(isPlaying == FALSE)
	global_frame->SetStatusBar("ΐJn{^ƐŊJn܂");
}

void CVsgomokuApp::OnGiveup() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  char buf[BUFSIZ];
  int size = packet.MakeGiveUpPacket(buf);
  EasySocket *socket = connection.GetSocket();
  socket->Send(buf,size);
  isPlaying = FALSE;
  AfxMessageBox("~Q܂BȂ̕łB",
				MB_OK|MB_ICONINFORMATION);
  global_frame->SetStatusBar("ΐJn{^ƐŊJn܂");
}

void CVsgomokuApp::OnUpdateGiveup(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->Enable(isPlaying);	
}

void CVsgomokuApp::OnGote() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  char buf[BUFSIZ];
  int size = packet.MakeStartPacket(buf,FALSE);
  EasySocket *socket = connection.GetSocket();
  socket->Send(buf,size);
  Start(FALSE);
  goban.SetMyTurn(FALSE);
  global_frame->SetStatusBar(MES_TEKITURN);
}

void CVsgomokuApp::OnUpdateGote(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->Enable(connection.IsConnect() && isPlaying == FALSE);	
}

void CVsgomokuApp::OnSente() 
{
  // TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  char buf[BUFSIZ];
  int size = packet.MakeStartPacket(buf,TRUE);
  EasySocket *socket = connection.GetSocket();
  socket->Send(buf,size);
  Start(TRUE);
  goban.SetMyTurn(TRUE);
  global_frame->SetStatusBar(MES_OWNTURN);
}

void CVsgomokuApp::OnUpdateSente(CCmdUI* pCmdUI) 
{
  // TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->Enable(connection.IsConnect() && isPlaying == FALSE);	
}

// w̐΂̃vC[f
WinLoseStatus CVsgomokuApp::CheckWinLose(int x, int y, char ishi)
{
  switch(goban.GetStatus(x,y,ishi)){
  case I_GO:
	return STATUS_WIN;
  case I_CHOREN:
	// ŒȀꍇA
	if(ishi == ISHI_KURO)
	  return STATUS_LOSE;
	else
	  return STATUS_WIN;
	break;
  case I_YONYON:
  case I_SANSAN:
	// ŎOOAll̏ꍇA
	if(ishi == ISHI_KURO)
	  return STATUS_LOSE;
	else
	  return STATUS_NONE;
	break;
  }
  return STATUS_NONE;
}


BOOL CAboutDlg::OnInitDialog() 
{
  CDialog::OnInitDialog();
  // X^bt[̓̃f[^ݒ
  static ChipsDrawing drawingDef[] = {
	{2000,3000,500,C_RANDOM},
	{500,2000,500,C_TOP},
	{500,2000,500,C_TOP},
	{500,2000,500,C_TOP},
	{1000,2000,1000,C_RIGHT},
	{1000,2000,1000,C_LEFT},
	{1000,2000,1000,C_BOTTOM},
	{1000,2000,1000,C_RANDOM},
	{3000,3000,500,C_POINT}};
	
	RECT rect;
	m_canvas.GetClientRect(&rect);
	CRect crect(rect);
	CDC *pDC = m_canvas.GetDC();
	doubleBuff.SetCDC(pDC);
	doubleBuff.Initialize(&crect);
	m_canvas.ReleaseDC(pDC);
	animation.Create("about.dat", 4,&rect,drawingDef);
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

CVsgomokuApp::~CVsgomokuApp()
{
  delete about;
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
  if(nIDEvent == ID_CANVASTIMER){
	CDC *pDC = m_canvas.GetDC();
	doubleBuff.SetCDC(pDC);
	if(animation.GetStatus() == RUNNING){
	  doubleBuff.ClearCanvas();
	  animation.Move(doubleBuff.GetHDC());
	}
	doubleBuff.Update();
	m_canvas.UpdateWindow();
	m_canvas.ReleaseDC(pDC);
  }

  CDialog::OnTimer(nIDEvent);
}

void CAboutDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
  KillTimer(ID_CANVASTIMER);	
  CDialog::OnOK();
}

void CAboutDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	// EBhE\ꂽiKŃ^C}[ݒ肵܂B
	// OnInitDialogŃ^C}[ݒ肷ƁAx}Vł
	// EBhE\ȂƂ悤ł̂

	if(animation.GetStatus() != NOTREADY){
	  animation.Start();
	  SetTimer(ID_CANVASTIMER,10,NULL);
	}
}
