#include "DoubleBuff.h"

DoubleBuff::DoubleBuff()
{
  memDC = NULL;
  dispBuf = NULL;
}

DoubleBuff::~DoubleBuff()
{
  delete memDC;
  delete dispBuf;
}

void DoubleBuff::DrawLine(int x1,int y1, int x2,int y2)
{
  CPen* oldPen;
  oldPen = (CPen*)memDC->SelectStockObject(BLACK_PEN);
  memDC->MoveTo(x1,y1);
  memDC->LineTo(x2,y2);
  memDC->SelectObject(oldPen);
}

void DoubleBuff::ClearCanvas()
{
  memDC->FillSolidRect(&clientRect,0xffffff);
}

void DoubleBuff::Initialize(CRect* rct)
{
  clientRect = rct;
  TRACE("INITIALIZE: %d,%d\n",clientRect.Width(),clientRect.Height());
  CreateBitmap();
}
// ̃rbg}bvʂɓ]܂B
void DoubleBuff::Update()
{
  displayDC->BitBlt(0,0,
                    clientRect.Width(),clientRect.Height(),
                    memDC,0,0,SRCCOPY);
}

// Ƀrbg}bv𐶐܂B
void DoubleBuff::CreateBitmap()
{
  if(memDC != NULL)
    return;
  
  dispBuf = new CBitmap;
  dispBuf->CreateCompatibleBitmap(displayDC,
								  clientRect.Width(),clientRect.Height());
  memDC = new CDC;
  memDC->CreateCompatibleDC(displayDC);
  memDC->SelectObject(dispBuf);
  memDC->FillSolidRect(&clientRect,0xffffff);
  
  //  createFont(0,"Terminal");
}

int DoubleBuff::CreateFont(int id,char* fontname)
{
#if 0
  if(id < 0 || id >= FONTNUM)
    return -1;
  if(myFont[id] == NULL)
    myFont[id] = new CFont;
  else
    delete myFont[id];

  LOGFONT lf;
  lf.lfHeight = -18;
  lf.lfWidth = 0;
  lf.lfEscapement = 0;
  lf.lfOrientation = 0;
  lf.lfWeight = 0;
  lf.lfItalic = 0;
  lf.lfUnderline = 0;
  lf.lfStrikeOut = 0;
  lf.lfCharSet = DEFAULT_CHARSET;
  lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
  lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  lf.lfQuality = DEFAULT_QUALITY;
  lf.lfPitchAndFamily = FIXED_PITCH;
  // tHgގw
  strcpy(lf.lfFaceName, "lr SVbN");
  //  strcpy(lf.lfFaceName, "FixedSys");
  
  // ݒ肵OtHgŃtHg쐬
  if (!myFont[id]->CreateFontIndirect(&lf))
    return -1;		// sꍇ
  // VtHgI
#endif
  return 0;
}
                        
void DoubleBuff::DrawString(int x,int y,char* str,int fontID)
{
  //  CFont *oldfont = (CFont*)memDC->SelectObject(myFont[fontID]);
  memDC->TextOut(x,y,str,strlen(str));
  //  memDC->SelectObject(oldfont);
}
