// EasySocket.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "EasySocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EasySocket
EasySocket::EasySocket()
{
  status = S_NONE;
  receiveCallback = NULL;
  receiveCallbackData = NULL;
  connectCallback = NULL;
  connectCallbackData = NULL;
  closeCallback = NULL;
  closeCallbackData = NULL;

  serverSocket = NULL;
}

EasySocket::~EasySocket()
{
}


// ClassWizard KvƂȉ̍sҏWȂłB
#if 0
BEGIN_MESSAGE_MAP(EasySocket, CAsyncSocket)
	//{{AFX_MSG_MAP(EasySocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// EasySocket o֐

void EasySocket::OnAccept(int nErrorCode) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
  SOCKADDR_IN cl_addr;
  int addrLen = sizeof(cl_addr);
  serverSocket = new EasySocket;
  
  if (!Accept(*serverSocket,(LPSOCKADDR)&cl_addr, &addrLen)) {
	if (GetLastError() != WSAEWOULDBLOCK) {
	  SetError("ڑł܂łBG[R[h %d",
			   GetLastError());
	}
  } else {
	strcpy(serverSocket->hostname,inet_ntoa(cl_addr.sin_addr));
	TRACE("%s Ɛڑ܂",serverSocket->hostname);
  }
  serverSocket->status = S_CONNECT;
  CAsyncSocket::OnAccept(nErrorCode);

  if(connectCallback != NULL)
	connectCallback(serverSocket,connectCallbackData);
}

void EasySocket::OnClose(int nErrorCode) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
  CAsyncSocket::OnClose(nErrorCode);

  if(closeCallback != NULL)
	closeCallback(closeCallbackData);
}

void EasySocket::OnConnect(int nErrorCode) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
  CAsyncSocket::OnConnect(nErrorCode);

  if(nErrorCode == 0){
	if (!AsyncSelect(FD_READ|FD_CLOSE)) {
	  SetError("READ̃Cxgݒ肪o܂ł G[R[h %d",
			   GetLastError());
	}
	TRACE("%s Ɛڑ܂\n",hostname);
	status = S_CONNECT;
  } else {
	status = S_NONE;
	SetError("T[o[Ɛڑł܂łBErrorCode %d",
			 nErrorCode);
  }
}

void EasySocket::OnOutOfBandData(int nErrorCode) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CAsyncSocket::OnOutOfBandData(nErrorCode);
}

void EasySocket::OnReceive(int nErrorCode) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
  if(receiveCallback != NULL)
	receiveCallback(receiveCallbackData);
  CAsyncSocket::OnReceive(nErrorCode);
}

void EasySocket::OnSend(int nErrorCode) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CAsyncSocket::OnSend(nErrorCode);
}

int EasySocket::Receive(void* lpBuf, int nBufLen, int nFlags) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	return CAsyncSocket::Receive(lpBuf, nBufLen, nFlags);
}

int EasySocket::Send(const void* lpBuf, int nBufLen, int nFlags) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	return CAsyncSocket::Send(lpBuf, nBufLen, nFlags);
}

int EasySocket::WaitClient(int port,void (*func)(EasySocket *,void *), void* data)
{
  connectCallback = func;
  connectCallbackData = data;

  if(!Create(port,SOCK_STREAM,FD_ACCEPT|FD_READ|FD_CLOSE,NULL)){
	SetError("\Pbgł܂łBG[R[h %d",
			 GetLastError());
	return FALSE;
  }	
  if(!Listen(1)){
	SetError("ڑ҂ł܂łBG[R[h %d",
			 GetLastError());
	Close();
	return FALSE;
  }
  TRACE("NCAg̐ڑ҂łB\n");
  status = S_WAIT;
  return TRUE;
}

int EasySocket::ConnectServer(char* host,int port)
{
  if(gethostbyname(host) == NULL){
	SetError("zXg擾ł܂B(%s)", host);
	return FALSE;
  }
  strcpy(hostname,host);
  Create(0, SOCK_STREAM, FD_CONNECT, NULL);
  if(!Connect(host,port)){
	if (GetLastError()  != WSAEWOULDBLOCK) {
	  SetError("T[o[Ɛڑł܂łBErrorCode %d",
			   GetLastError());
	  return FALSE;
	} else {
	  // {ɐڑ(OnConnectĂ΂)܂ŃubN
	  MSG msg;
	  status = S_WAIT;
	  while(status == S_WAIT){
		if(GetMessage(&msg,NULL,0,0) <= 0)
		  break;  // FIXME!: breakł́H
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	  }
	  if(status == S_NONE){
		return FALSE;
	  }
	}
  }
  return TRUE;
}

void EasySocket::SetReceiveCallback(void (*func)(void*),void* data)
{
  receiveCallback = func;
  receiveCallbackData = data;
}

void EasySocket::SetCloseCallback(void (*func)(void*),void* data)
{
  closeCallback = func;
  closeCallbackData = data;
}

void EasySocket::SetError(char* fmt, ...)
{
  va_list args;
  va_start(args,fmt);
  vsprintf(lastError,fmt,args);
  va_end(args);
  TRACE("%s",lastError);
}
