#if !defined(AFX_EASYSOCKET_H__DDC0E6D0_9DD4_11D2_85C8_043E06C10000__INCLUDED_)
#define AFX_EASYSOCKET_H__DDC0E6D0_9DD4_11D2_85C8_043E06C10000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// EasySocket.h : wb_[ t@C
//

enum SOCKET_STATUS { S_NONE,S_WAIT,S_CONNECT,S_CLOSE };

/////////////////////////////////////////////////////////////////////////////
// EasySocket R}h ^[Qbg

class EasySocket : public CAsyncSocket
{
// Agr[g
public:

// Iy[V
public:
	EasySocket();
	virtual ~EasySocket();

// I[o[Ch
public:
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(EasySocket)
	public:
	virtual void OnAccept(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	virtual void OnConnect(int nErrorCode);
	virtual void OnOutOfBandData(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual void OnSend(int nErrorCode);
	virtual int Receive(void* lpBuf, int nBufLen, int nFlags = 0);
	virtual int Send(const void* lpBuf, int nBufLen, int nFlags = 0);
	//}}AFX_VIRTUAL

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(EasySocket)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
	//}}AFX_MSG

// Cve[V
public:
  int WaitClient(int port,void (*func)(EasySocket *,void *), void* data);
  int ConnectServer(char* host,int port);
  int IsConnected() { return status & S_CONNECT;}
  int IsWaiting() { return status & S_WAIT;}
  void SetReceiveCallback(void (*func)(void*),void* data);
  void SetCloseCallback(void (*func)(void*),void* data);
  char *GetErrorMsg() { return lastError;}

protected:
private:
  void SetError(char* format, ...);
  char lastError[BUFSIZ];
  char hostname[BUFSIZ];
  EasySocket *serverSocket;
  SOCKET_STATUS status;
  void *receiveCallbackData;
  void (*receiveCallback)(void*);
  void *connectCallbackData;
  void (*connectCallback)(EasySocket *server,void *data);
  void *closeCallbackData;
  void (*closeCallback)(void*);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_EASYSOCKET_H__DDC0E6D0_9DD4_11D2_85C8_043E06C10000__INCLUDED_)
