#ifndef _GOBAN_H_
#define _GOBAN_H_

#include "gomoku.h"

#define MY_TURN 0
#define TEKI_TURN 1

enum IshiStatus { I_NONE, I_SAN, I_SANSAN, I_YON, I_YONYON, I_GO, I_CHOREN};

class Goban {
public:
  Goban();
  int  IsMyTurn() {
	return myTurn;
  }
  void SetMyTurn(int t){
	myTurn = t;
  }

  void SetMyIshi(int ishi){
	ishiMine = ishi;
  }

  char GetMyIshi(){
	return ishiMine;
  }

  char GetTekiIshi(){
	if(ishiMine == ISHI_KURO)
	  return ISHI_SHIRO;
	else
	  return ISHI_KURO;
  }

  char GetIshi(int x,int y){
	return goban[y][x];
  }
  int SetIshi(int x,int y,int turn);
  void InitGoban();
  // x,y܂ޕ3,4,5𒲂ׂ
  IshiStatus GetStatus(int x, int y, char ishi);
  
private:
  int IsCorrect(int x, int y){
	if(x < 0 || y < 0 || x >= GOBAN_X_NUM || y >= GOBAN_Y_NUM
	   || goban[y][x] != ISHI_NONE)
	  return FALSE;
	else
	  return TRUE;
  }
  char* GetIshiPattern(char* str,char ishi);
  int IsSan(char *str,char ishi);
  int IsYon(char *str,char ishi);
  int IsGo(char *str,char ishi);
  int IsChoren(char *str,char ishi);
  char* GetLine(int x, int y,int mode);

  char goban[GOBAN_Y_NUM+1][GOBAN_X_NUM+1];
  char ishiMine;
  int myTurn;
};

#endif
