#ifndef _PARSEPACKET_H_
#define _PARSEPACKET_H_

// vgŔA
// ComHeader + g
// łB
// +-----------------+----------------+
// |    ComHeader    | g           |
// +-----------------+----------------+
// |             |            |
//  sizeof(ComHeader)  ComHeader.packetSize
// vgR̒g

#define PROTOCOLVER "GO_1.0"

enum ComType { C_START, C_POSITION, C_GIVEUP};

class PacketItem {
public:
  PacketItem() {}
  // w̃AhXɓeRs[
  // ߂l Rs[TCY
  void CopyThis(void* ptr,int size);
protected:
  void SetField(char* ptr,int n);
  void SetField(char* ptr,char* str);
};

class ComHeader : public PacketItem {
public:
  ComHeader() {}
  ComHeader(ComType type, int size){
	SetField(version,PROTOCOLVER);
	SetField(packetType,type);
	SetField(packetSize,size);
  }
  char* GetVersion(){
	return version;
  }
  ComType GetPacketType(){
	return (ComType)atoi(packetType);
  }
  int GetPacketSize(){
	return atoi(packetSize);
  }
private:
  char version[8];
  char packetType[8];
  char packetSize[8];
  char yobi[64];
};

class ComStart : public PacketItem {
public:
  ComStart(){}
  ComStart(int _isSente){
	SetField(isSente,_isSente);
  }
  int GetIsSente(){
	return atoi(isSente);
  }
private:
  char isSente[8];   // 1 肪 
                  // 0 
};
  
class ComPosition : public PacketItem {
public:
  ComPosition(){}
  ComPosition(int _x, int _y){
	SetField(x,_x);
	SetField(y,_y);
  }
  int GetX(){
	return atoi(x);
  }
  int GetY(){
	return atoi(y);
  }
private:
  char x[8];       // ΂ꏊ X
  char y[8];       // ΂ꏊ Y
};


class MakePacket {
public:
  MakePacket() {}
  int MakePositionPacket(char* buf,int x, int y);
  int MakeStartPacket(char* buf, int isSente);
  int MakeGiveUpPacket(char* buf);
};
  
#endif
