// vsgomokuView.cpp : CVsgomokuView NX̓̒`s܂B
//

#include "stdafx.h"
#include "vsgomoku.h"

#include "vsgomokuDoc.h"
#include "vsgomokuView.h"
#include "DoubleBuff.h"
#include "gomoku.h"
#include "Goban.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVsgomokuView* global_view;
/////////////////////////////////////////////////////////////////////////////
// CVsgomokuView

IMPLEMENT_DYNCREATE(CVsgomokuView, CView)

BEGIN_MESSAGE_MAP(CVsgomokuView, CView)
	//{{AFX_MSG_MAP(CVsgomokuView)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuView NX̍\z/

CVsgomokuView::CVsgomokuView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
  global_view = this;
}

CVsgomokuView::~CVsgomokuView()
{
}

BOOL CVsgomokuView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuView NX̕`

void CVsgomokuView::OnDraw(CDC* pDC)
{
  static int isFirst = TRUE;
  CVsgomokuDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  draw.SetCDC(pDC);

  if(isFirst){

	kuroBitmap.LoadBitmap(IDB_KURO);
	kuroDC.CreateCompatibleDC(pDC);
	kuroDC.SelectObject(&kuroBitmap);
	shiroBitmap.LoadBitmap(IDB_SHIRO);
	shiroDC.CreateCompatibleDC(pDC);
	shiroDC.SelectObject(&shiroBitmap);
	maskBitmap.LoadBitmap(IDB_MASK);
	maskDC.CreateCompatibleDC(pDC);
	maskDC.SelectObject(&maskBitmap);
	gobanBitmap.LoadBitmap(IDB_GOBAN);
	gobanDC.CreateCompatibleDC(pDC);
	gobanDC.SelectObject(&gobanBitmap);

	InitGoban();

	isFirst = FALSE;
  }
  draw.Update();
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuView NX̐ff

#ifdef _DEBUG
void CVsgomokuView::AssertValid() const
{
	CView::AssertValid();
}

void CVsgomokuView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CVsgomokuDoc* CVsgomokuView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVsgomokuDoc)));
	return (CVsgomokuDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVsgomokuView NX̃bZ[W nh

void CVsgomokuView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
  int x,y;
  x = (point.x - XOFFSET + ISHISTEP/2 )/ISHISTEP;
  y = (point.y - YOFFSET + ISHISTEP/2 )/ISHISTEP;
  CView::OnLButtonDown(nFlags, point);
  if(global_app->connection.IsConnect() == FALSE){
	AfxMessageBox("ΐ̃}VƐڑĂ܂");
	return;
  }
  global_app->SetIshi(x,y,MY_TURN);
}

int CVsgomokuView::SetIshi(int x, int y, int turn)
{
  int posx,posy;
  posx = x*ISHISTEP+XOFFSET-XOFFSET/2 +1;
  posy = y*ISHISTEP+YOFFSET-YOFFSET/2 +1;

  TRACE("X:%d, Y:%d\n",posx,posy);

  draw.GetCDC()->BitBlt(posx,posy,
						ISHIBITMAP_SIZE,ISHIBITMAP_SIZE,
						&maskDC,
						0,0,SRCAND);
  draw.GetCDC()->BitBlt(posx,posy,
						ISHIBITMAP_SIZE,ISHIBITMAP_SIZE,
						turn == ISHI_KURO ? &kuroDC : &shiroDC,
						0,0,SRCPAINT);
  Invalidate(FALSE);
  UpdateWindow();
	return TRUE;
}

void CVsgomokuView::InitGoban()
{
  CRect rct;
  GetClientRect(&rct);
  draw.Initialize(&rct);

  draw.GetCDC()->BitBlt(0,0,
						GOBANBITMAP_SIZE,GOBANBITMAP_SIZE,
						&gobanDC,
						0,0,SRCCOPY);
}
